<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Load all orders - Danh sách đơn hàng</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>

<body onload="onPageLoading()">
    <div class="container-fluid pt-4">
        <h2 class="text-center pb-3">Danh sách đơn hàng</h2>
        <table class="table text-center table-striped" id="table-order">
            <thead>
                <tr>
                    <th scope="col">Order Code</th>
                    <th scope="col">Kích cỡ combo</th>
                    <th scope="col">Loại pizza</th>
                    <th scope="col">Nước uống</th>
                    <th scope="col">Thành tiền</th>
                    <th scope="col">Họ và tên</th>
                    <th scope="col">Số điện thoại</th>
                    <th scope="col">Trạng thái</th>
                    <th scope="col">Chi tiết</th>
                </tr>
            </thead>
            <tbody>
                
            </tbody>
        </table>
    </div>

    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gREQUEST_STATUS_OK = 200;
        const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;

        const gEND_OF_TABLE_ROW = -1;
        const gCOL_ORDER_CODE = 0;
        const gCOL_KICH_CO = 1;
        const gCOL_LOAI_PIZZA = 2;
        const gCOL_NUOC_UONG = 3;
        const gCOL_THANH_TIEN = 4;
        const gCOL_HO_TEN = 5;
        const gCOL_DIEN_THOAI = 6;
        const gCOL_TRANG_THAI = 7;
        const gCOL_CHI_TIET = 8;

        const gAPI_URL_GETALL_ORDERS = "http://203.171.20.210:8080/devcamp-pizza365/orders";


        /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */


        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // Hàm thực hiện khi load trang
        function onPageLoading() {
            getAllOrders();
        }

        function onBtnDetailClick(paramButtonDetail){
            var vOrderId = paramButtonDetail.dataset.id;
            var vOrderCode = paramButtonDetail.dataset.code;

            console.log("Order ID : " + vOrderId);
            console.log("Order Code : " + vOrderCode);
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // Hàm thực hiện việc load all orders từ server và load vào table
        function getAllOrders() {
            /**
           * Chia để trị - 04 bước cố gắng thành 04 functions riêng biệt
           */
            // B1: Thu thập dữ liệu (trong bài này bước này ko cần)
            // B2: Validate dữ liệu (trong bài này bước này ko cần)
            // B3: Thực hiện việc gọi API từ server Server
            var vXmlHttpGetAllOrders = new XMLHttpRequest();
            callApiToGetAllOrders(vXmlHttpGetAllOrders);

            // B4: Xử lý trên front-end khi request xử lý xong và trả về response thành công
            vXmlHttpGetAllOrders.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    loadOrderToTable(vXmlHttpGetAllOrders);
                }
            }
        }

        // hàm gọi api để lấy all orders
        function callApiToGetAllOrders(paramXMLHttpGetAllOrders) {            
            paramXMLHttpGetAllOrders.open("GET", gAPI_URL_GETALL_ORDERS, true);
            paramXMLHttpGetAllOrders.send();
        }

        // input: xml http request đã đươc trả lời
        // ouptut/end: dữ liệu hiên thi trên bảng
        function loadOrderToTable(paramXMLHttpAllOrder) {
            //CODE Ở ĐÂY ĐỂ LOAD DATA VÀO TABLE
            //console.log(paramXMLHttpAllOrder.responseText);
            var vOrderJsonObject = JSON.parse(paramXMLHttpAllOrder.responseText);
            var vOrderTable = document.getElementById("table-order");
            var vOrderBodyTable = vOrderTable.getElementsByTagName("tbody")[0];

            for(var bI=0; bI<vOrderJsonObject.length ; bI++){
                var bNewRow = vOrderBodyTable.insertRow(gEND_OF_TABLE_ROW);
                var bOrderCodeCell = bNewRow.insertCell(gCOL_ORDER_CODE);
                var bOrderKichCo = bNewRow.insertCell(gCOL_KICH_CO);
                var bOrderLoaiPizza = bNewRow.insertCell(gCOL_LOAI_PIZZA);
                var bOrderNuocUong = bNewRow.insertCell(gCOL_NUOC_UONG);
                var bOrderThanhTien = bNewRow.insertCell(gCOL_THANH_TIEN);
                var bOrderHoTen = bNewRow.insertCell(gCOL_HO_TEN);
                var bOrderDienThoai = bNewRow.insertCell(gCOL_DIEN_THOAI);
                var bOrderTrangThai = bNewRow.insertCell(gCOL_TRANG_THAI);
                var bOrderChiTiet = bNewRow.insertCell(gCOL_CHI_TIET); 

                // Chen du lieu
                bOrderCodeCell.innerHTML = vOrderJsonObject[bI].orderCode;
                bOrderKichCo.innerHTML = vOrderJsonObject[bI].kichCo;
                bOrderLoaiPizza.innerHTML = vOrderJsonObject[bI].loaiPizza;
                bOrderNuocUong.innerHTML = vOrderJsonObject[bI].idLoaiNuocUong;
                bOrderThanhTien.innerHTML = vOrderJsonObject[bI].thanhTien;
                bOrderHoTen.innerHTML = vOrderJsonObject[bI].hoTen;
                bOrderDienThoai.innerHTML = vOrderJsonObject[bI].soDienThoai;
                bOrderTrangThai.innerHTML = vOrderJsonObject[bI].trangThai;

                var bDetailButton = document.createElement("button");
                bDetailButton.innerHTML = "Chi tiết";
                bDetailButton.className = "btn btn-info";
                bDetailButton.setAttribute("data-id",vOrderJsonObject[bI].id);
                bDetailButton.setAttribute("data-code",vOrderJsonObject[bI].orderCode);

                bDetailButton.addEventListener("click", function(){
                    onBtnDetailClick(this);
                });

                bOrderChiTiet.appendChild(bDetailButton);

            }
            
        }

    </script>
</body>

</html>